
// written in the D programming language

module samples.ChipmunkDemo;

import chipmunkd.chipmunk;

import drawSpace;

import core.stdc.stdlib;

alias cpSpace *function() demoInitFunc;
alias void function(int ticks) demoUpdateFunc;
alias void function()demoDestroyFunc;

struct chipmunkDemo {
	string name;

	const drawSpaceOptions *drawOptions;
	
	demoInitFunc	initFunc;
	demoUpdateFunc	updateFunc;
	demoDestroyFunc destroyFunc;
}

// special hack for OSX
version(OSX) import std.random:uniform;

static cpFloat
frand()
{
version(OSX){
	return std.random.uniform(0,1);	
}else{
	return cast(cpFloat)rand()/cast(cpFloat)RAND_MAX;
}
}

enum GRABABLE_MASK_BIT = (1<<31);
enum NOT_GRABABLE_MASK = (~GRABABLE_MASK_BIT);
